//
//  RootViewController.h
//  uPnp
//
//  Created by rk on 2/01/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "UpnpManager.h"
#import "UpnpDevice.h"
#import "MBProgressHUD.h"

@class DetailViewController;

@interface RootViewController : UITableViewController <MBProgressHUDDelegate,UpnpDeviceDelegate> {
	UpnpManager *_upnpManager;
    DetailViewController *_detailViewController;
	MBProgressHUD *_hud;
	BOOL _discoveringDevices; // true while background thread is discovering devices
	NSMutableArray *_temporaryDevices; // temporary - don't use this in code, it's used in background thread
	NSMutableArray *_devices; // of NSURL of found devices;
}

@property (nonatomic, retain) UpnpManager *_upnpManager;
@property (nonatomic, retain) IBOutlet DetailViewController *_detailViewController;
@property (nonatomic, retain) NSMutableArray *_devices;
@property (nonatomic, readonly) NSMutableArray *rendererDevices; // items in _devices which are renderers
@property (nonatomic, readonly) NSMutableArray *serverDevices; // items in _devices which are servers
@property (nonatomic, readonly) NSMutableArray *otherDevices; // items in _devices which are neither renderers nor servers

- (IBAction)discoverDevices: (id)sender;

#pragma mark MBProgressHUDDelegate methods
- (void)hudWasHidden;


@end
