//
//  UpnpAvRenderingControlService.h
//  uPnp2
//
//  Created by rk on 26/01/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "UpnpDevice.h"
#import "UpnpAvService.h"



@interface UpnpAvRenderingControlService : UpnpAvService <AsynchUpnpCommandDelegate>{
	UpnpAvService *service;
	int desiredVolume; // -1 == unspecified
	<AsynchUpnpCommandDelegate> desiredVolumeResponseHandler;
	bool volumeChangeIsPending; // true while we're waiting for setvolume response
}

-(id)initWithService:(UpnpAvService *)theService;

#pragma mark AsynchUpnpCommandDelegate methods
- (void)handleAsynchUpnpCommandResult:(XMLTreeNode *)parsedResult;

#pragma mark -
- (void)asynchGetMute:(<AsynchUpnpCommandDelegate>)responseHandler;
- (void)asynchSetMute:(BOOL)newValue : (<AsynchUpnpCommandDelegate>)responseHandler;
- (void)asynchGetVolume:(<AsynchUpnpCommandDelegate>)responseHandler;
- (void)asynchSetVolume:(int)newValue : (<AsynchUpnpCommandDelegate>)responseHandler;

#pragma mark Private methods
- (void)sendSetVolumeCommand:(int)newValue;

#pragma mark Static Utility Methods
+(bool)isGetMuteResponse:(XMLTreeNode *)parsedResult;
+(bool)isSetMuteResponse:(XMLTreeNode *)parsedResult;
+(bool)isGetVolumeResponse:(XMLTreeNode *)parsedResult;
+(bool)isSetVolumeResponse:(XMLTreeNode *)parsedResult;
+(bool)getMuteResponseValue:(XMLTreeNode *)parsedResult;
+(int)getVolumeResponseValue:(XMLTreeNode *)parsedResult; // returns -1 if the input is not a response from GetVolume command


@end
