//
//  UpnpAvService.h
//  uPnp2
//
//  Created by rk on 27/01/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "UpnpAvXmlFetchable.h"
#import "AsynchUpnpCommand.h"
#import "XMLTreeNode.h"


@interface UpnpAvService : UpnpAvXmlFetchable <UpnpAvXmlFetchableDelegate> {
	id device; // UpnpDevice *
	NSString *serviceType;
	NSString *serviceId;
	NSString *scpdUrl;
	NSString *controlURL;
	NSString *eventSubURL;
	
	XMLTreeNode *parsedServiceDescription; // parsed SCPD element of service info
//	UpnpDevice *device;

}

@property (nonatomic, readonly) BOOL isRenderingControl;
@property (nonatomic, readonly) BOOL isContentDirectory;
@property (nonatomic, readonly) BOOL isConnectionManager;
@property (nonatomic, readonly) BOOL isAvTransport;

@property (nonatomic, retain) NSString *serviceType;
@property (nonatomic, retain) NSString *serviceId;
@property (nonatomic, retain) NSString *scpdUrl;
@property (nonatomic, retain) NSString *controlURL;
@property (nonatomic, retain) NSString *eventSubURL;

@property (nonatomic, retain) XMLTreeNode *parsedServiceDescription;

@property (nonatomic, assign) id device;

-(id) initWithDevice:(id)ownerDevice;
-(void) executeCommandAsync:(AsynchUpnpCommand*)command;


@end
